<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side
          ref="treeSide"
          :dataLoading="treeLoading"
          :default-expand-all="false"
          :defaultProps="defaultProps"
          :tabList="['组织路段树']"
          :treeData="treeData"
          isDeselect
          @currentChange="currentChange"
        ></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <div class="search-box-combination">
              <div class="search-box-label">报案时间：</div>
              <div>
                <el-date-picker
                  v-model="params.querys[5].value"
                  end-placeholder="报案时间"
                  range-separator="至"
                  start-placeholder="报案时间"
                  style="width: 360px"
                  type="datetimerange"
                  value-format="yyyy-MM-dd HH:mm:ss"
                  :default-time="['00:00:00', '23:59:59']"
                  @change="datePickerChange"
                >
                </el-date-picker>
              </div>
              <SearchCommon :optionList="optionList" @search="handleSearch" />
            </div>
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button
                  :disabled="isAddDisabled"
                  class="btn btn-plus"
                  icon="el-icon-plus"
                  size="small"
                  type="primary"
                  @click="
                  changePage(
                    'EditAddPage',
                    {roadId: treeItem.id},
                    '登记'
                  )
                "
                >
                  登记
                </el-button>
                <el-button
                  :disabled="!currentDataDel.length"
                  class="btn btn-delete"
                  icon="el-icon-delete"
                  plain
                  size="small"
                  type="danger"
                  @click="handleDelete"
                >
                  删除
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table
                  ref="multipleSelection"
                  v-loading="tableLoading"
                  :data="tableData"
                  :default-sort="{ prop: 'rescueTime', order: 'descending' }"
                  :max-height="tableMaxHeight"
                  border
                  class="table-list"
                  element-loading-background="rgba(10 ,38 ,61, 0.9)"
                  row-key="id"
                  stripe
                  @select="handleSelection"
                  @selection-change="handleSelectionChange"
                  @row-dblclick="handleDbClick"
                >
                  <el-table-column
                    :selectable="selectable"
                    align="center"
                    type="selection"
                    width="55"
                  />
                  <el-table-column
                    align="center"
                    label="序号"
                    type="index"
                    width="60"
                  />
                  <el-table-column
                    align="center"
                    label="救援单号"
                    min-width="120"
                    prop="rescueNo"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    align="center"
                    label="报案电话"
                    min-width="80"
                    prop="rescueTel"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    align="center"
                    label="报案时间"
                    min-width="120"
                    prop="rescueTime"
                    show-overflow-tooltip
                    sortable
                  />
                  <el-table-column
                    align="center"
                    label="救援点位桩号"
                    min-width="100"
                    prop="pegVal"
                    show-overflow-tooltip
                  />
                  
                  <!-- <el-table-column
                    align="center"
                    label="报案来源"
                    min-width="80"
                    prop="rescueSrc"
                    show-overflow-tooltip
                  >
                    <template v-slot="{row}">
                      {{ dictionaryEscape('baly', row.rescueSrc + '') || '-' }}
                    </template>
                  </el-table-column> -->
                  <el-table-column
                    align="center"
                    label="所属路段"
                    min-width="80"
                    prop="roadName"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    align="center"
                    label="救援类型"
                    min-width="80"
                    prop="rescueType"
                    show-overflow-tooltip
                  >
                    <template v-slot="{row}">
                      {{ dictionaryEscape('jylx', row.rescueType + '') || '-' }}
                    </template>
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="开始站"
                    min-width="80"
                    prop="startPatrolName"
                    show-overflow-tooltip
                  >
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="结束站"
                    min-width="80"
                    prop="endPatrolName"
                    show-overflow-tooltip
                  >
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="登记人"
                    min-width="80"
                    prop="createName"
                    show-overflow-tooltip
                  >
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="处置状态"
                    min-width="80"
                    prop="status"
                    show-overflow-tooltip
                  >
                  <template v-slot="{row}">
                      <el-link
                        :type="
                          row.status === 1
                            ? 'danger'
                            : row.status === 0
                            ? 'success'
                            : 'info'
                        "
                        :underline="false"
                      >
                        {{ dictionaryEscape('sjczzt',  String(row.status)) || '-' }}
                      </el-link>
                    </template>
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="救援状态"
                    prop="rescueStatus"
                    width="100"
                  >
                    <template v-slot="{row}">
                      <el-link
                        :type="
                          row.rescueStatus < 2
                            ? 'warning'
                            : row.rescueStatus == '2'
                            ? 'primary'
                            : row.rescueStatus == '4' || row.rescueStatus == '5'
                            ? 'success'
                            : 'danger'
                        "
                        :underline="false"
                      >
                        {{
                          dictionaryEscape('jy_zt', String(row.rescueStatus))
                        }}
                      </el-link>
                    </template>
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="操作"
                    min-width="120"
                    show-overflow-tooltip
                  >
                    <template v-slot="{row}">
                      <el-link
                        v-if="row.rescueStatus < '1'"
                        :underline="false"
                        type="primary"
                        @click="changePage('EditAddPage', row, '编辑')"
                      >
                        编辑
                      </el-link>
                      <el-link
                        v-if="row.rescueStatus == '1'"
                        :underline="false"
                        type="danger"
                        @click="revocation(row)"
                      >
                        撤回
                      </el-link>
                      <el-link
                        :underline="false"
                        type="primary"
                        @click="handleDetailPage(row)"
                      >
                        详情
                      </el-link>
                    </template>
                  </el-table-column>
                </el-table>
                <pagination
                  ref="paginationPanel"
                  :pageResult="params.pageBean"
                  style="margin-top: 10px"
                  @size-change="handleSizeChange"
                  @current-change="handleCurrentChange"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!--  目录树修改新增弹层  -->
    <tree-dialog
      :id.sync="treeItemId"
      :is-show.sync="treeDialog"
      :parent-id.sync="treeItemParentId"
      @catalogChange="catalogChange"
    />
  </div>
</template>

<script>
import {dictionaryEscape, getDictionaryByCode} from '@/utils/dictionary'
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import treeSide from '@/components/treeSide/index.vue'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {revocation, tableData, tableDelete} from '@/api/patrolAndRescue/obstacleClearingRescue/rescueRegistration'
import TreeDialog from './components/TreeDialog/index.vue'
import PubSub from 'pubsub-js'
import moment from 'moment'
import {getTree} from '@/api/tree'

export default {
  name: 'TablePage',
  components: {
    TreeDialog,
    pagination,
    treeSide,
    SearchCommon
  },
  mixins: [TableMixin],
  data() {
    return {
      pubSub: null,
      tableMaxHeight: '600px',
      loading: false,
      tableLoading: false,
      treeData: [], //左边树
      tabList: ['政策法规'], //左边tab
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      treeLoading: false,
      tableData: [],
      currentDataDel: [],
      optionList: [
        {title: '救援单号', prop: ['RESCUE_NO_'], type: 'input', default: true},
        {
          title: '救援类型',
          prop: ['RESCUE_TYPE_'],
          type: 'select',
          option: getDictionaryByCode('jylx'),
          multiple: true
        },
        {
          title: '报案来源',
          prop: ['RESCUE_SRC_'],
          type: 'select',
          option: getDictionaryByCode('baly'),
          multiple: true
        },
        {
          title: '故障车类',
          prop: ['CAR_CLASS_'],
          type: 'select',
          option: getDictionaryByCode('gzcl'),
          multiple: true
        },
        {
          title: '占道情况',
          prop: ['occupy_'],
          type: 'select',
          option: getDictionaryByCode('zdqk'),
          multiple: true
        },
        {title: '开始站', prop: 'START_PATROL_NAME_', type: 'input'},
        {title: '结束站', prop: 'END_PATROL_NAME_', type: 'input'},
        {
          title: '处置状态',
          prop: ['STATUS_'],
          type: 'select',
          option: getDictionaryByCode('sjczzt'),
          multiple: true
        },
        // { title: '所属路段', prop: ['road_Name_'], type: 'input', default: true },
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'IN', property: 'roadId'},
          {operation: 'IN', property: 'RESCUE_TYPE_', value: ''},
          {operation: 'IN', property: 'RESCUE_SRC_', value: ''},
          {operation: 'IN', property: 'CAR_CLASS_', value: ''},
          {operation: 'EQUAL', property: 'RESCUE_NO_', value: ''},
          {
            operation: 'BETWEEN',
            property: 'rescue_time_',
            value: [
              moment()
                .startOf('month')
                .format('YYYY-MM-DD HH:mm:ss'),
              moment()
                .endOf('month')
                .format('YYYY-MM-DD HH:mm:ss')
            ]
          },
          {operation: 'IN', property: 'occupy_', value: ''},
          {operation: 'EQUAL', property: 'START_PATROL_NAME_', value: ''},
          {operation: 'EQUAL', property: 'END_PATROL_NAME_', value: ''},
          {operation: 'IN', property: 'STATUS_', value: ''}
        ],
        sorter: [{property: 'createTime', direction: 'DESC'}] // 排序字段
      },
      treeDialog: false, // 科目信息弹层
      treeItemId: '', // 树形目录id
      treeItem: {}, // 树形节点选中对象
      treeItemParentId: '', // 树形目录父级id
      isAddDisabled: true
    }
  },
  created() {
    // 获取树形目录-
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id) //通过 $refs 获取treeSide组件引用，并调用 setCurrentKey方法设置当前选中的树节点。
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'roadId', array) //将选中的树节点的 path 设置为查询参数的一部分，用于后续的表格数据请求。
      this.loadData() //加载表格数据
    })
  },
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.params.pageBean.page = 1
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })
  },
  methods: {
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    // 时间范围切换
    datePickerChange(val) {
      setQueryValue(this.params, 'rescue_time_', val)
      this.params.pageBean.page = 1
      this.loadData()
    },
    // 获取公司树-异步方法，用于从后端获取树形数据
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true //开始加载时显示加载状态
        let {value} = await getTree() // 调用 API 获取树形数据
        this.treeData = [value]
      } finally {
        this.treeLoading = false // 无论成功或失败，都关闭加载状态
        callback && callback(this.treeData) // 如果提供了回调函数，则调用它并传入树形数据
      }
    },
    transformTreeData(data) {
      return {
        name: data.name,
        id: data.id,
        children: data.children.reduce((acc, child) => {
          acc.push({
            id: child.id,
            name: child.name,
            path: child.path,
            children: child.roadList.map(road => ({
              id: road.id,
              name: road.name,
              path: road.path
            }))
          })
          return acc
        }, [])
      }
    },

    selectable(row, index) {
      return true
      // return row.rescueStatus < '1'
    },
    // 删除
    handleDelete() {
      this.clickTimer = true
      this.$confirm('确定删除选中的事件信息吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(async () => {
          let ids = this.currentDataDel.join()
          let {state, message} = await tableDelete(ids)
          if (state) {
            this.$message.success(`事件删除成功`)
            const {page, pageSize, total} = this.params.pageBean
            const totalPages = Math.ceil(total / pageSize) // 计算总页数
            if (totalPages > 1 && page === totalPages) {
              if (this.tableData.length === 1) {
                // 当前页只有一条数据
                this.params.pageBean.page -= 1 // 返回前一页
              }
            }
            await this.loadData()
          } else {
            this.$message.error(message)
          }
        })
        .catch(_ => _)
    },
    // 撤回
    revocation({id}) {
      this.$confirm('确定撤回救援委派吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        const {state} = await revocation(id)
        if (state) {
          this.$message.success('撤回成功！')
          this.loadData()
        }
      })
    },
    dictionaryEscape,
    //获取科目树
    async getTreeData(callback) {
      this.treeData = [
        {
          name: '规章制度',
          edit: 1,
          id: '',
          parentId: '',
          children: await getTree('3')
        }
      ]
      // 保证重新刷新树数据后，选中效果不失效
      if (this.treeItem.id) {
        this.$nextTick(_ => {
          this.$refs.treeSide?.setCurrentKey(this.treeItem.id)
        })
      }
      callback && callback(this.treeData)
    },

    //获取数据
    async loadData() {
      this.tableLoading = true
      const {total = 0, rows = []} = await tableData(
        refineRequestBody(this.params)
      )
      this.params.pageBean.total = total
      this.tableData = rows
      this.tableLoading = false
    },

    //左边树节点
    currentChange(nodeItem) {
      if (nodeItem.id === '1766017468444450816') {
        this.isAddDisabled = true
        setQueryValue(this.params, 'roadId', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isAddDisabled = true
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'roadId', array)
      } else {
        this.isAddDisabled = false
        setQueryValue(this.params, 'roadId', [nodeItem?.id] || [])
      }
      // // 判断是否是一级目录（有 children 属性）
      // if (nodeItem.children && nodeItem.children.length > 0) {
      //   this.isAddDisabled = true // 禁用新增按钮
      //   // this.$message.warning('请选择二级目录进行新增操作')
      //   const array = nodeItem.children.map(item => item.id)
      //   setQueryValue(this.params, 'roadId ', array)
      // } else {
      //   this.isAddDisabled = false // 启用新增按钮
      //   // 修改对应的字段值
      //   setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      // }
      this.params.pageBean.page = 1
      this.calcTableHeight(500)
      PubSub.publish('TreeItemSelected', nodeItem)
      this.treeItem = nodeItem || {}
      this.loadData()
    },

    // 树节点操作
    operateEvent(type, data) {
      switch (type) {
        case '新增':
          this.treeItemParentId = data.id
          this.treeDialog = true
          break
        case '编辑':
          this.treeItemId = data.id
          this.treeItemParentId = data.parentId
          this.treeDialog = true
          break
        case '删除':
          this.$confirm('确定删除选中资料分类吗？', '提示', {
            confirmButtonText: '确认',
            cancelButtonText: '取消',
            type: 'warning'
          })
            .then(async () => {
              const {state} = await treeDelete(data.id)
              if (state) {
                this.$message.success(`删除资料分类成功`)
              } else {
                this.$message.error(`删除资料分类失败`)
              }
              await this.getTreeData()
            })
            .catch(_ => _)
          break
      }
    },

    // 目录改变
    catalogChange(dialogName) {
      this.getTreeData(_ => (this[dialogName] = false))
    },

    //修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      if (row.rescueStatus > 0) return
      this.changePage('EditAddPage', row)
    },

    // 改变页面
    changePage(pageName = '', row = {}, type = '') {
      if (!pageName) return

      this.$emit(
        'changePage',
        pageName,
        _ => {
          PubSub.publish(pageName, row)
        },
        type || '详情'
      )
    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped></style>
